﻿namespace SilverlightApplication1.Web.Services
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using SilverlightApplication1.Web.Models;

    // Implements application logic using the salesEntities context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class SalesService : LinqToEntitiesDomainService<salesEntities>
    {
        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Orders' query.
        public IQueryable<Order> GetOrders()
        {
            return this.ObjectContext.Orders;
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Orders' query.
        public IQueryable<Order_Details_Extended> GetOrderDetailsExtendeds()
        {
            return this.ObjectContext.Order_Details_Extendeds;
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'ProductCategories' query.
        public IQueryable<ProductCategory> GetProductCategories()
        {
            return this.ObjectContext.ProductCategories;
        }

        public IQueryable<SalesByCategory_Result> GetSalesByCategory(string categoryName, string ordYear)
        {
            return this.ObjectContext.SalesByCategory(categoryName, ordYear).AsQueryable<SalesByCategory_Result>();
        }

        public IList<Year> GetDistinctOrderYears()
        {
            return this.ObjectContext.Orders.Where(order => order.OrderDate.HasValue)
                       .Select(order => order.OrderDate.Value.Year)
                       .Distinct()
                       .Select(id => new Year() { ID = id })
                       .ToList();
        }
    }

    public class Year
    {
        [Key]
        public int ID { get; set; }
    }
}
