﻿
namespace SilverlightApplication1.Web.Models
{
	using System;
	using System.Collections.Generic;
	using System.ComponentModel;
	using System.ComponentModel.DataAnnotations;
	using System.Linq;
	using System.ServiceModel.DomainServices.Hosting;
	using System.ServiceModel.DomainServices.Server;


	// The MetadataTypeAttribute identifies OrderMetadata as the class
	// that carries additional metadata for the Order class.
	[MetadataTypeAttribute(typeof(Order.OrderMetadata))]
	public partial class Order
	{

		// This class allows you to attach custom attributes to properties
		// of the Order class.
		//
		// For example, the following marks the Xyz property as a
		// required property and specifies the format for valid values:
		//    [Required]
		//    [RegularExpression("[A-Z][A-Za-z0-9]*")]
		//    [StringLength(32)]
		//    public string Xyz { get; set; }
		internal sealed class OrderMetadata
		{

			// Metadata classes are not meant to be instantiated.
			private OrderMetadata()
			{
			}

			public string CustomerID { get; set; }

			public Nullable<int> EmployeeID { get; set; }

			public Nullable<decimal> Freight { get; set; }

			public Nullable<DateTime> OrderDate { get; set; }

			public int OrderID { get; set; }

			public Nullable<DateTime> RequiredDate { get; set; }

			public string ShipAddress { get; set; }

			public string ShipCity { get; set; }

			public string ShipCountry { get; set; }

			public string ShipName { get; set; }

			public Nullable<DateTime> ShippedDate { get; set; }

			public string ShipPostalCode { get; set; }

			public string ShipRegion { get; set; }

			public Nullable<int> ShipVia { get; set; }
		}
	}

	// The MetadataTypeAttribute identifies ProductCategoryMetadata as the class
	// that carries additional metadata for the ProductCategory class.
	[MetadataTypeAttribute(typeof(ProductCategory.ProductCategoryMetadata))]
	public partial class ProductCategory
	{

		// This class allows you to attach custom attributes to properties
		// of the ProductCategory class.
		//
		// For example, the following marks the Xyz property as a
		// required property and specifies the format for valid values:
		//    [Required]
		//    [RegularExpression("[A-Z][A-Za-z0-9]*")]
		//    [StringLength(32)]
		//    public string Xyz { get; set; }
		internal sealed class ProductCategoryMetadata
		{

			// Metadata classes are not meant to be instantiated.
			private ProductCategoryMetadata()
			{
			}

			public int CategoryID { get; set; }

			public string CategoryName { get; set; }

			public string Description { get; set; }

			public byte[] Picture { get; set; }
		}
	}
}
